=== debian/changelog ===
kaidan (0.7.0-1) unstable; urgency=medium

  * New upstream release (0.7.0):
    - Features:
       o Display client information (name, version, OS) of contacts (jbb, lnj)
       o Drag'n'drop for sending files (jbb)
       o Allow pasting images from the clipboard (Ctrl+Shift+V) into the chat
         (jbb)
       o Allow inserting newlines using Shift+Enter (jbb)
       o Add configuration of custom hostname/port (jbb, melvo)
       o Favourite emojis are shown by default now (melvo)
       o Search emojis by ":<name>" (melvo)
       o Display connection errors in the global drawer after login (melvo)
       o Improved design of media preview sheets (jbb)
       o Restructure message sending bar (melvo)
   - Bugfixes:
       o Do not interpret random URLs as files anymore (lnj)
       o Fix the style of buttons when using Material style (melvo)
       o Fix file dialog and media drawer opening in some cases (melvo)
       o Fix opening of the LoginPage when scanning QR code without password
         (melvo)
  * Add Debian XMPP Maintainers to the uploaders at their request.
  * Update build dependencies according to the upstream build system:
    - Qt >= 5.14
    - add qml-module-org-kde-qqc2desktopstyle to runtime dependencies
  * Refresh copyright information.
  * Update watch file to point to new release location.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 02 Feb 2021 19:40:30 +0100

kaidan (0.6.0-2) unstable; urgency=medium

  * Release to unstable.
  * Add missing build dependency to libgstreamer1.0-dev.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 06 Jan 2021 08:12:41 +0100

kaidan (0.6.0-1) experimental; urgency=medium

  * Initial release (Closes: #976376)

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 15 Dec 2020 22:41:50 +0100
