=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.3~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.40.0~),
               libgstreamer1.0-dev,
               libkf5notifications-dev (>= 5.67.0~),
               libqxmpp-dev (>= 1.2.0~),
               libqt5svg5-dev (>= 5.14.0~),
               libzxingcore-dev,
               kirigami2-dev (>= 5.67.0~),
               pkg-kde-tools,
               qtbase5-dev (>= 5.14.0~),
               qtlocation5-dev (>= 5.14.0~),
               qtmultimedia5-dev (>= 5.14.0~),
               qtpositioning5-dev (>= 5.14.0~),
               qtquickcontrols2-5-dev (>= 5.14.0~),
               qttools5-dev (>= 5.14.0~),
Standards-Version: 4.5.1
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: qml-module-org-kde-kirigami2 (>= 5.67.0~),
         qml-module-org-kde-qqc2desktopstyle (>= 5.67.0~),
         qml-module-qtgraphicaleffects (>= 5.14.0~),
         qml-module-qtlocation (>= 5.14.0~),
         qml-module-qtmultimedia (>= 5.14.0~),
         qml-module-qtpositioning (>= 5.14.0~),
         qml-module-qtqml (>= 5.14.0~),
         qml-module-qtquick-controls2 (>= 5.14.0~),
         qml-module-qtquick-dialogs (>= 5.14.0~),
         qml-module-qtquick-layouts (>= 5.14.0~),
         qml-module-qtquick2 (>= 5.14.0~),
         ${shlibs:Depends},
         ${misc:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.
