=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/unstable/@PACKAGE@/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
