## kaidan 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,9 +20,9 @@
 
 # Version
 set(VERSION_MAJOR 0)
-set(VERSION_MINOR 7)
+set(VERSION_MINOR 8)
 set(VERSION_PATCH 0)
-set(VERSION_CODE 11)
+set(VERSION_CODE 12)
 set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")
 
 set(DEVELOPMENT_BUILD FALSE)
@@ -74,10 +74,10 @@
 kde_enable_exceptions()
 
 # Find packages
-find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
+find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Concurrent Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
 find_package(KF5Kirigami2 ${KF5_MIN_VERSION} REQUIRED)
 find_package(ZXing REQUIRED)
-find_package(QXmpp 1.2.0 REQUIRED)
+find_package(QXmpp 1.3.0 REQUIRED)
 
 # Optional QtQuickCompiler
 if(QUICK_COMPILER)
@@ -97,7 +97,7 @@
 # Optional QWidget style integration (not on mobile)
 if(NOT UBUNTU_TOUCH AND NOT ANDROID AND NOT IOS)
 	find_package(Qt5Widgets)
-	find_package(KF5QQC2DeskopStyle)
+	find_package(KF5QQC2DesktopStyle)
 	set_package_properties(Qt5Widgets PROPERTIES
 		DESCRIPTION "Integration with QWidget based desktop styles"
 		TYPE OPTIONAL
