=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+add_compile_definitions(
+	QXMPP_DISABLE_DEPRECATED_BEFORE=0x010400
+)
+
 # set Kaidans sources (used in main cmake file)
 set(KAIDAN_SOURCES
 	src/main.cpp
@@ -50,6 +54,7 @@
 	src/ServerListModel.cpp
 	src/ServerListItem.cpp
 	src/AccountManager.cpp
+	src/VCardCache.cpp
 
 	# needed to trigger moc generation / to be displayed in IDEs
 	src/Enums.h
