=== debian/changelog ===
kaidan (0.8.0-2) unstable; urgency=medium

  * Update maintainer to use the @alioth-lists.debian.net address.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 27 Jan 2022 15:50:00 +0100

kaidan (0.8.0-1) experimental; urgency=medium

  [ Pino Toscano ]
  * Update the location in the watch file, the 0.7.0 bits were moved to the
    right structure.
  * Refer to common license file for Apache-2.0.
  * Re-export upstream signing key without extra signatures.

  [ Aurélien COUDERC ]
  * New upstream release (0.8.0).
    - Add typing notifications (XEP-0085: Chat State Notifications) (jbb)
    - Add message history syncing (XEP-0313: Message Archive Management) (lnj)
    - Window size is restored (melvo)
    - The server's website link is displayed if account creation is disabled
      (melvo)
    - Improved user strings & descriptions (melvo)
  * Update build dependencies according to the upstream build system:
    - QXmpp >= 1.3.0
    - add libkf5qqc2desktopstyle-dev
  * Refresh coyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 31 May 2021 00:06:38 +0200
