=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kaidan
 Section: net
 Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
 Build-Depends: cmake (>= 3.3~),
@@ -9,7 +9,8 @@
                extra-cmake-modules (>= 5.40.0~),
                libgstreamer1.0-dev,
                libkf5notifications-dev (>= 5.67.0~),
-               libqxmpp-dev (>= 1.2.0~),
+               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
+               libqxmpp-dev (>= 1.3.0~),
                libqt5svg5-dev (>= 5.14.0~),
                libzxingcore-dev,
                kirigami2-dev (>= 5.67.0~),
